/***************************************************************************
                          caplocal.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include	<errno.h>
#include	<unistd.h>
#include	<fcntl.h>

#include	<qlist.h>
#include	<ksock.h>

#include	"ksnuffle.h"
#include	"pcaphdr.h"
#include	"netpcap.h"
#include	"capture.h"
#include	"knd_pcaploc.h"

/*  CapLocal								*/
/*  CapLocal	: Constructor for local capture				*/
/*  pcaploc	: KNDPCapLoc *	: Parent object				*/
/*  (returns)	: CapLocal	:					*/

CapLocal::CapLocal
	(	KNDPCapLoc	*pcaploc
	)
	:
	pcaploc	(pcaploc)
{
}

/*  CapLocal								*/
/*  ~CapLocal	: Desstructor for local capture				*/
/*		:		:					*/

CapLocal::~CapLocal ()
{
}

/*  CapLocal								*/
/*  gotPacket	: Pass packet back to parent				*/
/*  pktinfo	: PktInfo *	: Packet data				*/
/*  (returns)	: void		:					*/

void	CapLocal::gotPacket
	(	PktInfo	*pktinfo
	)
{
	pcaploc->gotPacket (pktinfo) ;
}

/*  CapLocal								*/
/*  gotState	: Pass capture state back to parent			*/
/*  state	: MState	: Capture state				*/
/*  (returns)	: void		:					*/

void	CapLocal::gotState
	(	MState	state
	)
{
	pcaploc->gotState (state) ;
}


