/***************************************************************************
                         ctrlset.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999, 2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include	"ctrlset.h"

/*  KNDControlSet							*/
/*  addWidget	 : Add widget to control set				*/
/*  x, y, w, h	 : int, ...	: Geometry				*/
/*  type	 : CSType	: Control type				*/
/*  (returns)	 : void		:					*/

void	KNDControlSet::addWidget
	(	QWidget	*widget,
		int	x,
		int	y,
		int	w,
		int	h,
		CSType	type
	)
{
	controlSet.append   (widget) ;
	widget->hide	    () ;
	widget->setGeometry (x, y, w, h) ;

	if (widget->inherits ("QFrame") && ((type & CS_VALUE) != 0))
		((QFrame *)widget)->setFrameStyle (QFrame::Panel|QFrame::Sunken) ;

	if (widget->inherits ("QLabel"))
		((QLabel *)widget)->setAlignment  (type == Number ? AlignRight : AlignLeft) ;
}

/*  KNDControlSet							*/
/*  hide	 : Hide all widgets in set				*/
/*  (returns)	 : void		:					*/

void	KNDControlSet::hide ()
{
	QListIterator<QWidget>	iter (controlSet) ;
	QWidget			*lvobj		  ;

	while ((lvobj = iter.current ()) != NULL)
	{	lvobj->hide ()	;
		iter	+= 1	;
	}
}

/*  KNDControlSet							*/
/*  show	 : Show all widgets in set				*/
/*  (returns)	 : void		:					*/

void	KNDControlSet::show ()
{
	QListIterator<QWidget>	iter (controlSet) ;
	QWidget			*lvobj		  ;

	while ((lvobj = iter.current ()) != NULL)
	{	lvobj->show ()	;
		iter	+= 1	;
	}
}
