/***************************************************************************
                          knd_confmon.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_CONFMON_H 
#define		KND_CONFMON_H 


#include	"ksnuffle.h"
#include	"knd_config.h"
#include	"knd_filter.h"


/*  KNDConfMon								*/
/*  Base class used for the local and remote monitor configuration	*/
/*  objects.								*/

class	KNDConfMon : public KNDConf
{
	Q_OBJECT

protected :

	QLineEdit	t_logt	;	/* Text log file name		*/
	QLineEdit	t_logb	;	/* Binary log file name		*/
	QComboBox	s_log	;	/* Logging mode selection	*/
	LogMode		m_log	;	/* Logging mode type		*/

	QString		v_if	;	/* Interface name		*/
	QString		v_logt	;	/* Text log file name		*/
	QString		v_logb	;	/* Binary log file name		*/
	QLabel		l_if	;	/* Inteface label		*/
	QComboBox	s_if	;	/* Interface name list		*/
	QCheckBox	c_save	;	/* Save configuration		*/
	QLabel		l_snap	;	/* Snap length label		*/
	QLineEdit	t_snap	;	/* Snap length			*/
	int		v_snap	;	/* Value thereof		*/

	int		dflt_if	;	/* Default interface		*/
	QString		initPlug;	/* Initial plugin list		*/

public	:

	KNDConfMon  (KNDView	*,
		     KNDTrigger	*,
		     int,
		     cchar	*,
		     KConfig	*) ;

	virtual	~KNDConfMon ()	;

	virtual	void	writeConfig (KConfig *) ;
	virtual	void	initPlugins ()		;

protected slots :

	virtual	void	clickSet    () ;
	virtual	void	clickReset  () ;
	virtual	void	clickClear  () ;
	virtual	void	clickGo     () ;
	virtual	void	clickLog    () ;

	void	deltaLog    (int ) ;

public	:

	virtual	void	 AddIface   (cchar *) = 0 ;
	virtual	cchar	*getIface   () ;
	virtual	bool	 SaveMe	    () ;
}	;


/*  KNDConfLoc								*/
/*  Local sniffer configuration object ....				*/

class	KNDConfLoc : public KNDConfMon
{
public	:
	KNDConfLoc  (KNDView	*,
		     KNDTrigger	*,
		     int,
		     cchar	*,
		     SArray	*,
		     KConfig	*) ;

	virtual	~KNDConfLoc ()	;
	virtual	void	AddIface    (cchar   *) ;
}	;

/*  KNDConfRem								*/
/*  Remote sniffer configuration object ....				*/

class	KNDConfRem : public KNDConfMon
{
	QLabel	l_remote ;
	QLabel	t_remote ;
	SArray	sameif	 ;
	int	nsame	 ;

public	:
	KNDConfRem  (KNDView	*,
		     KNDTrigger	*,
		     int,
		     cchar	*,
		     cchar	*,
		     KConfig	*) ;

	virtual	~KNDConfRem ()	;
	virtual	void	AddIface    (cchar   *) ;
}	;

#endif	// KND_CONFMON_H 
