/***************************************************************************
                          knd_event.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_EVENT_H 
#define 	KND_EVENT_H 

#include	<ktabctl.h>

#include	"knd_plugin.h"
#include	"knd_filter.h"


/*  KNDEvent								*/
/*  Instances of this class are used to specify start and stop triggers	*/
/*  for sniffers and replayers.						*/

class	KNDEvent : public KNDPlugin
{
	Q_OBJECT

	KTabCtl		k_tabctl	;
	KNDFilter	*events[NEVENT]	;

	EventInf	eventinf	;

public	:
	KNDEvent	(KNDView *, KConfig *) ;
       ~KNDEvent	() ;

	EventInf	*getInfo    () ;

	void		writeConfig (KConfig *) ;
	void		clickSet    () ;
	void		clickReset  () ;
	void		clickClear  () ;

	virtual	cchar	*getLabel   () { return	"Events" ; } ;
	virtual	bool	isConfig    () { return	true	 ; } ;
}	;

#endif	// KND_EVENT_H 
