/***************************************************************************
                          knd_filter.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_FILTER_H 
#define		KND_FILTER_H 

#include	<qcheckbox.h>
#include	<qlabel.h>
#include	<qcombobox.h>
#include	<qlineedit.h>
#include	<qpushbutton.h>

#include	"ksnuffle.h"

enum	HostMode
{	Host		= 0,
	Srce		= 1,
	Dest		= 2
}	;

enum	JoinMode
{	And		= 0,
	Or		= 1
}	;

/*  KNDFilter								*/
/*  This class handles a filter program definition, either by selection	*/
/*  or by the user entering a specific tcpdump(8) style program.	*/

class	KNDFilter : public QWidget
{
	Q_OBJECT

	QCheckBox	c_prog		;

	QLabel		l_proto		;
	QComboBox	s_epro		;
	QComboBox	s_ipro		;
	QComboBox	s_host1		;
	QLineEdit	t_host1		;
	QComboBox	s_port1		;
	QComboBox	s_host2		;
	QLineEdit	t_host2		;
	QComboBox	s_port2		;
	QComboBox	s_andor		;
	QLineEdit	t_prog		;
	QPushButton	b_verify	;
	QLabel		l_exec		;
	QLineEdit	t_exec		;

	HostMode	m_host1		;
	HostMode	m_host2		;
	JoinMode	m_andor		;

	QString		v_epro		;
	QString		v_ipro		;
	QString		v_host1		;
	QString		v_host2		;
	QString		v_port1		;
	QString		v_port2		;
	QString		v_prog		;
	bool		v_andor		;
	bool		b_prog		;
	QString		v_exec		;

	
	QString		prefix		;	/* Configuration prefix	*/
	bool		hidden		;	/* Object is hidden	*/
	bool		replay		;	/* Replay object flag	*/
	bool		event		;	/* Event object flag	*/

	QString	&Pfx	  (char *)	;
	QString	buildProg ()		;
	void	addHost	  (QString &, HostMode, QString &, QString &) ;

private	slots :

	void	clickProg   (bool) ;
	void	deltaEProto (int ) ;
	void	verify	    ()	   ;

public	:

	/* There are two constructors. The first is used for monitors	*/
	/* where all fields are displayed and are available, while the	*/
	/* second is for replay, where we only display the program.	*/
	KNDFilter	(QWidget *, const char *, KConfig *, bool = false) ;
	KNDFilter	(QWidget *) ;

	void	clickReset  () ;
	void	clickSet    () ;
	void	clickClear  () ;
	void	writeConfig (KConfig *) ;

	inline	QString	&getProgram ()
	{
		return	v_prog	;
	}
	inline	QString	&getExec    ()
	{
		return	v_exec	;
	}

	inline	void	setProgram
		(	const char *prog
		)
	{
		t_prog.setText (v_prog = prog) ;
	}
}	;

#endif	// KND_FILTER_H 
