/***************************************************************************
                          knd_gra.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef 	KND_GRAPHIC_H 
#define 	KND_GRAPHIC_H 

#include	<qgroupbox.h>
#include	<qlabel.h>
#include	<qframe.h>

#include 	"ksnuffle.h"
#include	"knd_plugin.h"


class	KNDGraGrp : public QWidget
{
	QGroupBox	g_box		;
	QLabel		l_hist		;
	QLabel		l_bar1		;
	QLabel		l_bar2		;

	QFrame		*hist		;
	QFrame		*bar1		;
	QFrame		*bar2		;

	char		*title		;
	int		v_hist		;
	int		v_bar1		;
	int		v_bar2		;

public	:
	KNDGraGrp	(QFrame *, char *) ;

	void	setup	(QSize, int, int, int, QFrame *, QFrame *, QFrame *) ;
	void	resize	(QSize ) ;
	void	setMax	(char *) ;
}	;

/*  KNDGraphic								*/
/*  ----------								*/

class	KNDGraphic : public KNDPlugin
{
	Q_OBJECT	;

	KNDGraGrp	load		;
	KNDGraGrp	pkts		;

	KNDLoadHist	*loadHist	;
	KNDLoadBar	*loadBar1	;
	KNDLoadBar	*loadBar2	;
	int		loadScale	;

	KNDPktHist	*pktHist	;
	KNDPktBar	*pktBar1	;
	KNDPktBar	*pktBar2	;
	int		pktScale	;

	bool		onview		;
	bool		going		;
	bool		frozen		;

	int		v_hist		;
	int		v_bar1		;
	int		v_bar2		;

	int		grpwid		;
	int		grpht		;
	int		histwid		;

virtual	void	resizeEvent	(QResizeEvent  *) ;

public	:
	KNDGraphic	(KNDView *)	;
       ~KNDGraphic  	()		;

	virtual	void	paintAll	()	   ;

	virtual	void	addPacket 	(PktInfo *);
	virtual	void	*setOptions	(void	 *);
	virtual	void	setOnview	(bool)	   ;
	virtual	void	execute		(bool)	   ;
	virtual	void	freeze		(bool)	   ;
	virtual	void	timerTick	(long) 	   ;

	virtual	cchar	*getLabel   () { return	"Graphic" ; } ;
	virtual	bool	isConfig    () { return	false	  ; } ;
}	;

#endif // KND_GRAPHIC_H 
