/***************************************************************************
                          knd_mon.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include	"knd_mon.h"
#include	"knd_confmon.h"
#include	"knd_pcaploc.h"
#include	"knd_pkt.h"
#include	"knd_gra.h"
#include	"knd_trigger.h"
#include	"knd_multi.h"

/*  KNDMonitor								*/
/*  KNDMonitor	: Constructor for local monitor object			*/
/*  parent	: QWidget *	: Parent widget				*/
/*  app		: KNDApp  *	: Application object			*/
/*  slot	: int		: Slot in parent view list		*/
/*  iflist	: QArray<char*>*: Interface list			*/
/*  multi	: KNDMulti *	: Multiple graph object			*/
/*  prefilter	: ccahr *	: User packet pre-filter		*/
/*  appconf	: KConfig *	: Configuration information		*/
/*  (returns)	: KNDMonitor	:					*/

KNDMonitor::KNDMonitor
	(	QWidget		*parent,
		KNDApp		*app,
		int		slot,
		QArray<char *>	*iflist,
		KNDMulti	*multi,
		cchar		*prefilter,
		KConfig		*appconf
	)
	:
	KNDView	(parent, app, slot, "Monitor", false, multi, appconf)
{
	capture = new KNDPCapLoc (this, prefilter) ;
	config  = new KNDConfLoc (this, trigger, slot, name, iflist, appconf) ;

	addTabs	() ;
}

/*  KNDMonitor								*/
/*  ~KNDMonitor	: Destructor for view object				*/
/*  (returns)	:		:					*/

KNDMonitor::~KNDMonitor ()
{
}

/*  KNDMonitor								*/
/*  getMType	: Get monitor type					*/
/*  (returns)	: MType		:					*/

MType	KNDMonitor::getMType ()
{
	return	Monitor	;
}

/*  KNDMonitor								*/
/*  writeConfig	: Write monitor configuration				*/
/*  config	: KConfig *	: Configuration object			*/
/*  (returns)	: void		:					*/

void	KNDMonitor::writeConfig
	(	KConfig	*config
	)
{
	KNDView::writeConfig (config) ;
}
