/***************************************************************************
                          knd_pcaploc.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_PCAP_LOC_H 
#define		KND_PCAP_LOC_H 

#include	"ksnuffle.h"
#include	"knd_pcapmon.h"

/*  KNDPCapLoc	: Ksnuffle packet capture				*/
/*  Instance of this class handle a particular local capture		*/
/*  Configuration. There is one instance for each local monitor created	*/
/*  by the user.							*/

class	KNDPCapLoc : public KNDPCapMon
{
	Q_OBJECT

	CapLocal	capture	   ;	/* Underlying capture object	*/
	NetPCap		*netpcap   ;	/* Low-level capture object	*/
	int	  	snaplen	   ;	/* Packet snap length		*/
	KSocket		*ksock	   ;	/* For socket notification	*/
	cchar		*prefilter ;	/* Packet pre-filter		*/

	void	clear	() ;

public	:

	KNDPCapLoc 	 	 (KNDMonitor *, cchar *) ;
	virtual ~KNDPCapLoc	 () ;

	virtual	void	setProg	 (cchar *, TrigInf *, EventInf *, int) ;
	virtual	void	execute	 (bool, FILE * = NULL, bool = false) ;
	virtual	void	timerTick(long) ;

	virtual	PCapInf	*getInfo   () ;
	virtual	void	clickQuery () ;

	void		gotState   (MState   ) ;
	void		gotPacket  (PktInfo *) ;

public	slots :

	void	sockRead (KSocket *) ;
}	;

#endif	// KND_PCAP_LOC_H 
