/***************************************************************************
                          knd_pcapmon.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_PCAP_MON_H 
#define		KND_PCAP_MON_H 

#include	"ksnuffle.h"
#include	"knd_pcap.h"

class	SString : public QString
{
public	:

	inline	void	Append
		(	char	c
		)
	{
		static	char	c2[2]	;
		c2[0]	= c	;
		append	(c2)	;
	}

	inline	void	Append
		(	long	l
		)
	{
		append	(ItoA (l)) ;
	}
}	;

/*  KNDPCapMon	: Ksnuffle packet capture				*/
/*  Instance of this class handle a particular local or remote capture	*/
/*  configuration. There is one instance for each local created by the	*/
/*  user.								*/

class	KNDPCapMon : public KNDPCap
{
	Q_OBJECT

	cchar	*Substitute	 (cchar *, SString &, PktInfo *) ;
	cchar	*SubsEPoint	 (cchar *, SString &, EPoint  &) ;
	cchar	*SubsTime	 (cchar *, SString &, time_t   ) ;
	void	DelEvents	 () ;

public	:

	KNDPCapMon 	 	 (KNDView *) ;
	virtual ~KNDPCapMon	 () ;

	virtual	void	setProg	 (cchar *, TrigInf *, EventInf *, int) = 0 ;
	virtual	void	execute	 (bool, FILE * = NULL, bool = false) = 0 ;
	virtual	void	timerTick(long) = 0 ;

	virtual	PCapInf	*getInfo () = 0 ;

protected :

	PCapInf	pcapinf	;		/* Packet capture information	*/
	FILE	*logfd	;		/* Logging file descriptor	*/
	bool	binary	;		/* Logging binary		*/
	DECODER	*decoder;		/* Packet decoder		*/
	cchar	*events	[NEVENT] ;	/* Event commands		*/

	void	setLog	   (FILE *, bool)  ;
	void	gotPacket  (PktInfo  *)	   ;
	bool	gotEvent   (PktInfo  *)	   ;
	void	setEvents  (EventInf *)	   ;

	virtual	void	clickQuery  () = 0 ;
}	;


#endif	// KND_PCAP_MON_H 
