/***************************************************************************
                          knd_pcaprem.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_PCAP_REM_H 
#define		KND_PCAP_REM_H 


#include	"ksnuffle.h"
#include	"knd_pcapmon.h"

/*  KNDPCapRem	: Ksnuffle packet capture				*/
/*  Instance of this class handle a particular remote capture		*/
/*  Configuration. There is one instance for each remote monitor 	*/
/*  created by the user.						*/

class	KNDPCapRem : public KNDPCapMon
{
	Q_OBJECT

	KNDRemote *remote	;	/* Parent remote object		*/
	KSocket	  *ksock	;	/* Socket at KNDPCap end	*/
	QString	  pass		;	/* Remote password		*/
	cchar	  *prefilter	;	/* Packet pre-filter		*/

#define	NDSAMP	  (10)
	TVAL	  tdiff[NDSAMP]	;	/* Time differences		*/
	TVAL	  toff		;	/* Current time offset		*/
	int	  tnext		;	/* Next time difference slot	*/

	/* We have to be able to reconstruct incoming messages since	*/
	/* they may exceed the amount of data that will fit in a single	*/
	/* IP frame for TCP/IP.						*/
	char	  recbuff	[sizeof(PktInfo)] ;
	uint	  recsize	;

	void	SendRemCmd (int, cchar *) ;
	void	AdjTime	   (cchar   *)	  ;
	void	FixTime	   (PktInfo *)	  ;

public	:
	KNDPCapRem 		 (KNDRemote *, cchar *, cchar *, cchar *, cchar *) ;
	virtual	~KNDPCapRem	 () ;

	virtual	void	setProg	 (cchar *, TrigInf *, EventInf *, int) ;
	virtual	void	timerTick(long) ;
	virtual	void	execute	 (bool, FILE * = NULL, bool = false) ;

	virtual	PCapInf	*getInfo   () ;
	virtual	void	clickQuery () ;

public	slots :

	void	sockRead (KSocket *) ;
}	;

#endif	// KND_PCAP_REM_H 
