/***************************************************************************
                          knd_pcaprep.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_PCAP_REP_H 
#define		KND_PCAP_REP_H 

#include	"ksnuffle.h"
#include	"knd_pcap.h"

/*  KNDPCapRep	: Ksnuffle packet replay				*/
/*  Instance of this class handle a particular replay configuration. It	*/
/*  is made to look like a real packet capture to the rest of the	*/
/*  program.								*/

class	KNDPCapRep : public KNDPCap
{
	Q_OBJECT

	DECODER		*decoder;	/* Packet decoder		*/
	PktInfo		*pktinfo;	/* Data for next packet		*/
	TVAL		inctime	;	/* Time increment per tick	*/
	TVAL		reptime	;	/* Next replay packet time	*/

	int		logfd	;	/* Log file			*/
	int		v_speed	;	/* Replay speed-up/slow-down	*/

public	:

	KNDPCapRep 	 	 (KNDReplay *) ;
	virtual ~KNDPCapRep	 () ;

		void	setReplay(int, int, DECODER *) ;
	virtual	void	setProg	 (cchar *, TrigInf  *, EventInf *, int) ;
	virtual	void	execute	 (bool, FILE * = NULL, bool = false) ;
	virtual	void	timerTick(long) ;

	virtual	PCapInf	*getInfo   () ;
	virtual	void	clickQuery () ;
}	;

#endif	// KND_PCAP_REP_H 
