/***************************************************************************
                          knd_plugdlg.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef	KND_PLUGDLG_H
#define KND_PLUGDLG_H 

#include	<qlistview.h>
#include	<qpushbutton.h>
#include	<qmultilinedit.h>

#include	"ksnuffle.h"

class	KNDDlgItem	;
class	KNDDlgList	;

/*  KNDLVItem								*/
/*  We want to display loaded plugins in grey in the list, and arrange	*/
/*  that the user cannot select them. This class is used for each item,	*/
/*  and includes a flag to indicate that the entry should be greyed out	*/

class	KNDDlgItem : public QListViewItem
{
	QString	name	;
	QString	file	;

public	:
	KNDDlgItem (KNDDlgList *, cchar *, cchar *, cchar *, bool) ;

	bool	greyed	;

	inline	cchar	*getName  () { return name ; }
	inline	cchar	*getFile  () { return file ; }

protected :
	virtual	void	paintCell (QPainter *, const QColorGroup &, int, int, int) ;
}	;

/*  KNDListBox								*/
/*  Along with KNDLBItem, this class provides a list box with greyed	*/
/*  items that cannot be selected.					*/
 
class	KNDDlgList : public QListView
{
	Q_OBJECT

public	:

	KNDDlgList (QWidget *) ;

protected slots :

	void	select () ;
}	;


/*  KNDPLuginDialog							*/
/*  This dialog is used to select plugins to be added to a sniffer.	*/

class	KNDPluginDialog : public QDialog
{
	Q_OBJECT

	QLabel		label	;
	KNDDlgList	plugins	;
	QMultiLineEdit	info	;
	QPushButton	bOK	;
	QPushButton	bCancel	;

	QStrList	*res	;

public:
	KNDPluginDialog (QWidget *, QStrList *, QStrList *, bool);
       ~KNDPluginDialog () ;

protected slots:

	virtual	void	done    (int) ;
	virtual	void	current	(QListViewItem *) ;
}	;

#endif	/* KND_PLUGDLG_H */

