/***************************************************************************
                          knd_remote.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KND_REMOTE_H 
#define KND_REMOTE_H 

#include	<qlabel.h>
#include	<qlineedit.h>
#include	<qpushbutton.h>

#include	"ksnuffle.h"
#include	"knd_view.h"


/*  KNDRemDialog							*/
/*  Class used for dialog to prompt user for remote host name and	*/
/*  remote sniffer port.						*/

class	KNDRemDialog : public QDialog
{
	Q_OBJECT
	QLabel		lHost	;
	QLabel		lPort	;
	QLabel		lPass	;
	QLineEdit	eHost	;
	QLineEdit	ePort	;
	QLineEdit	ePass	;
	QPushButton	bOK	;
	QPushButton	bCancel	;

public:
	KNDRemDialog (QWidget *);
       ~KNDRemDialog () ;

protected slots:

	virtual	void	done (int) ;
}	;

/*  KNDRemote								*/
/*  Class used for remote sniffing. This class is almost completely	*/
/*  virtual; all the work is done in the configuration and packet	*/
/*  capture objects.							*/

class KNDRemote : public KNDView
{
	Q_OBJECT

	KNDConfRem	*remconf ;
	QString		remhost	 ;
	QString		remport	 ;
	QString		rempass	 ;

public:
	KNDRemote  (QWidget *, KNDApp	*, 
			       int,
			       cchar    *,
			       cchar	*,
			       cchar	*,
			       KNDMulti	*,
			       cchar	*,
			       KConfig	* = NULL) ;
	virtual	~KNDRemote () ;

	void		AddIface    (cchar   *) ;
	void		Finish	    () ;
	virtual	MType	getMType    () ;
	virtual	void	writeConfig (KConfig *) ;
}	;

#endif // KND_REMOTE_H 
