/***************************************************************************
                          knd_tcpdata.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef	KND_TCPDATA_H
#define	KND_TCPDATA_H

#include	<qscrollview.h>

#include	"ksnuffle.h"

/*  KNDTCPBytes								*/
/*  This is the class actually responsible for displaying TCP stream	*/
/*  data. It runs under the KNCTCPData class.				*/

class	KNDTCPBytes : public QScrollView
{
	QList<QString>	text		;	/* Lines of text	*/
	uint		maxcols		;	/* Maximum columns	*/
	int		minwidth	;	/* Mininim and maximum	*/
	int		minheight	;	/* ... sizes in pixels	*/

	void		doResize ()	;	/* Handle resizing	*/

protected :

	void	drawContentsOffset  (QPainter *, int, int, int, int, int, int) ;
	virtual	void	resizeEvent (QResizeEvent *) ;

public	:

	KNDTCPBytes (QWidget *)		;

	void	clear	()		;	/* Clear for new data	*/
	void	addData	(PktInfo *)	;	/* Add a packet		*/
	void	loaded	()		;	/* Signal data loaded	*/
}	;


/*  KNDTCPData								*/
/*  This class is used to implement the display of TCP stream data; it	*/
/*  contains a scroller to show the data.				*/

class	KNDTCPData : public KTMainWindow
{
	Q_OBJECT

	QString		name		;	/* Sniffer name		*/
	QString		iface		;	/* Interface name	*/

	KNDPacket	*parent		;	/* Parent KNDPacket	*/
	KNDTCPBytes	*bytes		;	/* Data display window	*/
	TCPHASH		*tcphash	;	/* Identifiers stream	*/

protected :

	virtual	void	closeEvent  (QCloseEvent  *) ;

public	:

	KNDTCPData (KNDPacket *, cchar *, cchar *) ;
       ~KNDTCPData () ;

	inline	void	clear	()
	{
		tcphash	= NULL	;
		bytes->clear	() ;
	}	;

	inline	void	addData
		(	PktInfo	*p
		)
	{ 
		bytes->addData	(p) ;
	}	;

	inline	void	loaded
		(	TCPHASH	*h
		)
	{
		tcphash	= h	;
		bytes->loaded 	()  ;
	} ;

public	slots :

	void	command	(int) ;
}	;

#endif	/* KND_TCPDATA_H */
