/***************************************************************************
                          knd_trigger.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_TRIGGER_H 
#define 	KND_TRIGGER_H 

#include	<ktabctl.h>
#include	<qbuttongroup.h>
#include	<qradiobutton.h>
#include	<qgroupbox.h>
#include	<qpushbutton.h>

#include	"knd_plugin.h"
#include	"knd_filter.h"

/*  KNDTrigger								*/
/*  Instances of this class are used to specify start and stop triggers	*/
/*  for sniffers and replayers.						*/

class	KNDTrigger : public KNDPlugin
{
	Q_OBJECT

	KTabCtl		k_tabctl	;
	KNDFilter	*filter		;
	KNDFilter	*start		;
	KNDFilter	*stop		;

	QButtonGroup	g_mode		;
	QRadioButton	b_all		;
	QRadioButton	b_tostop	;
	QRadioButton	b_fromstart	;
	QRadioButton	b_oneshot	;
	QRadioButton	b_repeat	;

	TrigInf		triginf		;
	void		setMode (int)	;

public	:
	KNDTrigger	(KNDView *, KConfig *) ;
       ~KNDTrigger	() ;

	TrigInf		*getInfo    () ;

	void		setTrigger  (TrigInf *) ;

	void		writeConfig (KConfig *) ;
	void		clickSet    () ;
	void		clickReset  () ;
	void		clickClear  () ;

protected slots :

	void	selectMode    (int) ;

public	:

	virtual	cchar	*getLabel   () { return	"Filter/Trigger" ; } ;
	virtual	bool	isConfig    () { return	true		 ; } ;
}	;

#endif	// KND_TRIGGER_H 
