/***************************************************************************
                          knd_user.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_USER_H
#define		KND_USER_H

#include	<qgroupbox.h>
#include	<qcheckbox.h>
#include	<qlabel.h>
#include	<qspinbox.h>
#include	<qlistbox.h>
#include	<qpushbutton.h>

#include	"ksnuffle.h"


/*  KNDPreFilter							*/
/*  Class used to get and modify user pre-filters; these can be set so	*/
/*  that a non-root user can see only a subset of network traffic.	*/

class	KNDPreFilter : public QDialog
{
	Q_OBJECT
	QLabel		lFilter	;
	QLineEdit	eFilter	;
	QPushButton	bOK	;
	QPushButton	bCancel	;

public	:
	KNDPreFilter	(QWidget *, cchar *, cchar *) ;
       ~KNDPreFilter	() ;

	inline	QString	getFilter ()
	{
		return	eFilter.text () ;
	}

protected slots :

	virtual	void	done (int) ;
}	;

/*  KNDUser								*/
/*  This is the class for the privileged user configuration and setup	*/
/*  object.								*/

class	KNDUser : public QWidget
{
	Q_OBJECT

	QGroupBox	g_users	 ;


	QListBox	u_all	 ;	/* List of all users		*/
	QListBox	u_full	 ;	/* Full privileged users	*/
	QListBox	u_view	 ;	/* View only users		*/
	QLabel		l_priv	 ;
	QLabel		l_view	 ;
	QPushButton	b_padd	 ;
	QPushButton	b_prem	 ;
	QPushButton	b_premall;
	QPushButton	b_vadd	 ;
	QPushButton	b_vrem	 ;
	QPushButton	b_vremall;
	QPushButton	b_saveu	 ;

	QPushButton	b_setuid ;

	KConfig		*uconf	 ;
	bool		setuid	 ;

public:

	KNDUser (KNDApp *parent, KConfig *) ;
       ~KNDUser () ;

protected slots:

	void		clickPAddUser	() ;
	void		clickPRemUser	() ;
	void		clickPRemAll	() ;
	void		clickVAddUser	() ;
	void		clickVRemUser	() ;
	void		clickVRemAll	() ;
	void		clickSaveUsers	() ;
	void		clickSetUID	() ;

	void		selectedP	(int)	  ;
	void		selectedV	(int)	  ;
	void		selected	(cchar *) ;
}	;

#endif	// KND_USER_H
