/***************************************************************************
                          main.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include	"unistd.h"
#include	"sys/types.h"
#include 	"ksnuffle.h" 

extern	void	getDomain	() ;
extern	void	startNsl	() ;
extern	void	decNetInit	() ;
extern	void	addPluginDir	(cchar *) ;

KApplication	*theApp	 ;

/*  main	: Standard entry routine				*/
/*  argc	: int		: Argument count			*/
/*  argv	: char *[]	: Argument vector			*/
/*  (returns)	: int		: Exit code				*/
 
int	main
	(	int	argc,
		char	*argv[]
	)
{
	bool	noNSL	= false ;

	argc	-= 1	;
	argv	+= 1	;

	QString	plugdir	= KApplication::kde_datadir () +
			  (QString)((const char *)"/ksnuffle/plugins") ;

	while ((argc > 0) && (argv[0][0] == '-'))
	{
		switch (argv[0][1])
		{
			case 'P' :
				/* This option is only allowed if the	*/
				/* real and effective UIDs are both	*/
				/* root, otherwise a non-root user who	*/
				/* is allowed to run KSnuffle could	*/
				/* load an arbitrary plugin ....	*/
				if ((getuid () == 0) && (geteuid () == 0))
				{	plugdir = "" ;
					addPluginDir (&argv[0][2]) ;
				}

				break	;

			case 'N' :
				/* Disable DNS lookup. Mainly to make	*/
				/* life easier when debugging.		*/
				noNSL	= true ;
				break	;

			default	 :
				break	;
		}

		argv	+= 1 ;
		argc	-= 1 ;
	}

	if (plugdir != "") addPluginDir (plugdir) ;
	
	/* Start the nameserver lookup process _before_ we do anything	*/
	/* KDE-like so that it doesn't get open connections related to	*/
	/* X11 and KDE.							*/
	getDomain () ;
	if (!noNSL) startNsl () ;
	decNetInit() ;

	KApplication	app (argc, argv, "ksnuffle") ;  
	theApp	= &app	;
 
	if (app.isRestored())
	{ 
		RESTORE	(KNDApp) ;
	}
	else 
	{
		KNDApp* kND = new KNDApp ;
		kND->show () ;
	}

	return	app.exec  () ;
}  
