/***************************************************************************
                          netpcap.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef	__NETPCAP_H
#define	__NETPCAP_H

#include	"pcaphdr.h"

class	CapBase		;
class	CapLocal	;
class	CapRemote	;
class	KSocket		;

/*  NetPCap								*/
/*  This is the real capture class which actually interfaces to the	*/
/*  libpcap stuff ....							*/

class	NetPCap
{
public	:
	NetPCap		*next	;

private	:
	char		*iface	;	/* Interface name		*/
	int		snaplen	;	/* Capture snap length		*/

	CapBase		*caplist;	/* Set of using capture objects	*/
	pcap_t	  	*pd	;	/* Monitor connection		*/
	BPFI32		netmask	;	/* Network mask			*/
	BPFPROG		preflt	;	/* User pre-filter		*/

public	:

	NetPCap	(cchar *, int, cchar *, bool &, char *) ;
       ~NetPCap	() ;

	bool	suitable	(cchar *,  int) ;
	void	addCapture	(CapBase *) ;
	bool	delCapture	(CapBase *) ;
	void	Callback	(const struct pcap_pkthdr *, const u_char *) ;

	inline	BPFI32	getNMask () { return netmask		; } ;
	inline	int	getLType () { return pcap_datalink (pd) ; } ;
	inline	pcap_t	*getPCap () { return pd			; } ;

	void	execute	 (bool)	     ;
	void	sockRead (int )	     ;
}	;

extern	NetPCap	*get_NetPCap	(CapBase *, cchar *, int, cchar *, bool &, char *) ;
extern	void	drop_NetPCap	(CapBase *, NetPCap *) ;

#endif	/* __NETPCAP_H */

