/***************************************************************************
                         knd_demo.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef	KND_SUMMARY_H
#define KND_SUMMARY_H 

#include	<qgroupbox.h>
#include	"ksnuffle.h"
#include	"ctrlset.h"
#include	"knd_plugin.h"

/*  Define a structure used to pass configuration between the		*/
/*  configuration plugin and the display plugin.			*/

struct	DemoConf
{
	QString	*value1	;
	QString	*value2	;
}	;

/*  KNDDemoConf								*/
/*  This is a demonstration configuration plugin.			*/

class	KNDDemoConf : public KNDPlugin
{
	Q_OBJECT

	KNDControlSet	ctrlSet		;
	QLineEdit	v_value1	;	/* First value		*/
	QLineEdit	v_value2	;	/* Second value		*/
	QString		s_value1	;	/* Set first value	*/
	QString		s_value2	;	/* Set second value	*/
	DemoConf	democonf	;	/* Config. passing	*/

public	:
	KNDDemoConf	(KNDView *, KConfig *);
       ~KNDDemoConf	()		;

	void	clickSet	  ()	;
	void	clickClear	  ()	;
	void	clickReset	  ()	;
	void	*setOptions	  (void *) ;

	virtual	cchar	*getLabel () { return "DemoConf" ; } ;
	virtual	bool	isConfig  () { return true	 ; } ;
}	;

/*  KNDDemoDisp								*/
/*  This is a demonstration display plugin.				*/

class	KNDDemoDisp : public KNDPlugin
{
	Q_OBJECT

	KNDControlSet	ctrlSet		;

	QLabel		v_value1	;	/* First value		*/
	QLabel		v_value2	;	/* Second value		*/
	QLabel		v_frozen	;	/* Something else	*/
	QLabel		v_pktcnt	;	/* Count packets	*/

	int		s_pktcnt	;	/* Counted packets	*/
	bool		going		;	/* Executing		*/
	bool		frozen		;	/* Display is frozen	*/
	bool		onview		;	/* Window is on view	*/

public	:

	KNDDemoDisp	(KNDView *, KConfig *);
       ~KNDDemoDisp	()		;

	void	*setOptions	(void    *) ;
	void	addPacket	(PktInfo *) ;
	void	setOnview	(bool)	 ;
	void	execute		(bool)	 ;
	void	freeze		(bool)	 ;

	virtual	cchar	*getLabel () { return "DemoDisp" ; } ;
	virtual	bool	isConfig  () { return false	 ; } ;
}	;


#endif	// KND_SUMMARY_H
