/***************************************************************************
                         knd_dns.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef	KND_DNS_H
#define KND_DNS_H 

#include	<qgroupbox.h>
#include	<qlistview.h>

#include	"ksnuffle.h"
#include	"ctrlset.h"
#include	"knd_plugin.h"

/*  KNDDNSItem								*/
/*  Class used for displayed items. Basically a QListViewItem with some	*/
/*  extra stored data.							*/

class	KNDDNSItem : public QListViewItem
{
	cchar	*request;
	cchar	*server	;
	int	ident	;

public	:
	KNDDNSItem	(QListView *, QListViewItem *,
				      cchar   *, cchar   *, int,
				      QString *, QString *,
				      cchar   *, cchar   *) ;

	bool	isReply	(cchar *, cchar *, int, QString *, cchar *) ;
}	;

/*  KNDDNS								*/
/*  The KNDDNS plugin can be used to display DNS traffic on the network	*/

class	KNDDNS : public KNDPlugin
{
	Q_OBJECT

	QListView	dnsInfo	;	/* Request/anwser display	*/
	int		domain	;	/* DNS server port		*/
	KNDDNSItem	*last	;	/* Last item displayed		*/
	int		nPkt	;	/* Number of packets displayed	*/
	QList<PktInfo>	pending	;	/* Packets pending while frozen	*/
	bool		frozen	;	/* Display is frozen		*/

	void		clear 		()	    ;
	void		putPacket	(PktInfo *) ;

public	:
	KNDDNS	(KNDView *, KConfig *);
       ~KNDDNS	()		;

	virtual	void	clickSet	()	;
	virtual	void	clickClear	()	;
	virtual	void	clickReset	()	;

	virtual	cchar	*getLabel () { return "DNS" ; } ;
	virtual	bool	isConfig  () { return false ; } ;

	virtual	void	addPacket	(PktInfo *) ;
	virtual	void	*setOptions	(void    *) ;
	virtual	void	execute		(bool	  ) ;
	virtual	void	freeze		(bool	  ) ;

	virtual	void	resizeEvent	(QResizeEvent *) ;
}	;



#endif	// KND_DNS_H
