/***************************************************************************
                        knd_summary.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include	<qtooltip.h>

#include	"ctrlset.h"
#include	"knd_summary.h"
#include	"knd_view.h"
#include	"knd_pcap.h"
#include	"nethdrs.h"

extern	bool	IPIsThisHost (cchar *) ;


/*  KNDSummary								*/
/*  KNDSummary	: Constructor for packet display object			*/
/*  parent	: KNDView *	: Parent				*/
/*  config	: KCOnfig *	: Configuration				*/
/*  (returns)	: KNDSummary	:					*/

KNDSummary::KNDSummary
	(	KNDView	*_parent,
		KConfig	*config
	)
	:
	KNDPlugin  (_parent, "KND__SUMMARY"),
	g_stats	   (this),
	l_accept   (this),
	l_dropped  (this),
	l_missed   (this),
	l_pktbytes (this),
	l_datbytes (this),
	l_in	   (this),
	l_out	   (this),
	l_pass	   (this),
	l_local	   (this),
	l_what	   (this),
	v_accepti  (this),
	v_accepto  (this),
	v_acceptp  (this),
	v_acceptl  (this),
	v_acceptu  (this),
	v_dropped  (this),
	v_missed   (this),
	v_pktbytesi(this),
	v_pktbyteso(this),
	v_pktbytesp(this),
	v_pktbytesl(this),
	v_pktbytesu(this),
	v_datbytesi(this),
	v_datbyteso(this),
	v_datbytesp(this),
	v_datbytesl(this),
	v_datbytesu(this)
{
	going	= false	;	/* Not at the moment ...		*/
	frozen	= false	;	/* ... nor this				*/

	l_dropped.hide	() ;
	l_missed .hide  () ;
	v_dropped.hide  () ;
	v_missed .hide  () ;

	ctrlSet.addWidget (&g_stats,      15,  15, 530, 115, None  ) ;
	ctrlSet.addWidget (&l_in,	 120,  30,  80,  20, Label ) ;
	ctrlSet.addWidget (&l_out,	 205,  30,  80,  20, Label ) ;
	ctrlSet.addWidget (&l_pass,	 290,  30,  80,  20, Label ) ;
	ctrlSet.addWidget (&l_local,	 375,  30,  80,  20, Label ) ;
	ctrlSet.addWidget (&l_what,	 460,  30,  80,  20, Label ) ;
	ctrlSet.addWidget (&l_accept,     20,  50,  90,  20, Label ) ;
	ctrlSet.addWidget (&v_accepti,   120,  50,  80,  20, Number) ;
	ctrlSet.addWidget (&v_accepto,   205,  50,  80,  20, Number) ;
	ctrlSet.addWidget (&v_acceptp,   290,  50,  80,  20, Number) ;
	ctrlSet.addWidget (&v_acceptl,   375,  50,  80,  20, Number) ;
	ctrlSet.addWidget (&v_acceptu,   460,  50,  80,  20, Number) ;
	ctrlSet.addWidget (&l_pktbytes,   20,  75,  90,  20, Label ) ;
	ctrlSet.addWidget (&v_pktbytesi, 120,  75,  80,  20, Number) ;
	ctrlSet.addWidget (&v_pktbyteso, 205,  75,  80,  20, Number) ;
	ctrlSet.addWidget (&v_pktbytesp, 290,  75,  80,  20, Number) ;
	ctrlSet.addWidget (&v_pktbytesl, 375,  75,  80,  20, Number) ;
	ctrlSet.addWidget (&v_pktbytesu, 460,  75,  80,  20, Number) ;
	ctrlSet.addWidget (&l_datbytes,   20, 100,  90,  20, Label ) ;
	ctrlSet.addWidget (&v_datbytesi, 120, 100,  80,  20, Number) ;
	ctrlSet.addWidget (&v_datbyteso, 205, 100,  80,  20, Number) ;
	ctrlSet.addWidget (&v_datbytesp, 290, 100,  80,  20, Number) ;
	ctrlSet.addWidget (&v_datbytesl, 375, 100,  80,  20, Number) ;
	ctrlSet.addWidget (&v_datbytesu, 460, 100,  80,  20, Number) ;

	v_accept  [Incoming]	= &v_accepti	;
	v_accept  [Outgoing]	= &v_accepto	;
	v_accept  [Passing ]	= &v_acceptp	;
	v_accept  [Local   ]	= &v_acceptl	;
	v_accept  [Unknown ]	= &v_acceptu	;

	v_pktbytes[Incoming]	= &v_pktbytesi	;
	v_pktbytes[Outgoing]	= &v_pktbyteso	;
	v_pktbytes[Passing ]	= &v_pktbytesp	;
	v_pktbytes[Local   ]	= &v_pktbytesl	;
	v_pktbytes[Unknown ]	= &v_pktbytesu	;

	v_datbytes[Incoming]	= &v_datbytesi	;
	v_datbytes[Outgoing]	= &v_datbyteso	;
	v_datbytes[Passing ]	= &v_datbytesp	;
	v_datbytes[Local   ]	= &v_datbytesl	;
	v_datbytes[Unknown ]	= &v_datbytesu	;

	g_stats	   .setTitle    (i18n("Summary"	     )) ;
	l_accept   .setText     (i18n("Packet count" )) ;
	l_pktbytes .setText     (i18n("Total traffic")) ;
	l_datbytes .setText     (i18n("Total data"   )) ;
	l_in	   .setText	(i18n("Incoming"     )) ;
	l_out	   .setText	(i18n("Outgoing"     )) ;
	l_pass	   .setText	(i18n("Passing"	     )) ;
	l_local	   .setText	(i18n("Local"	     )) ;
	l_what	   .setText	(i18n("Unknown"	     )) ;

	QToolTip::add (&v_accepti,   i18n("Captured incoming packets")) ;
	QToolTip::add (&v_accepto,   i18n("Captured outgoing packets")) ;
	QToolTip::add (&v_acceptp,   i18n("Captured passing on network")) ;
	QToolTip::add (&v_acceptl,   i18n("Captured packets local to this host")) ;
	QToolTip::add (&v_acceptu,   i18n("Captured packets with unknown direction")) ;
	QToolTip::add (&v_pktbytesi, i18n("Total number of incoming bytes")) ;
	QToolTip::add (&v_pktbyteso, i18n("Total number of outgoing bytes")) ;
	QToolTip::add (&v_pktbytesp, i18n("Total number of bytes passing on network")) ;
	QToolTip::add (&v_pktbytesl, i18n("Total number of bytes local to this host")) ;
	QToolTip::add (&v_pktbytesu, i18n("Total number of bytes with unknown direction")) ;
	QToolTip::add (&v_datbytesi, i18n("Total incoming data")) ;
	QToolTip::add (&v_datbyteso, i18n("Total outgoing data")) ;
	QToolTip::add (&v_datbytesp, i18n("Total data passing on network")) ;
	QToolTip::add (&v_datbytesl, i18n("Total data local to this host")) ;
	QToolTip::add (&v_datbytesu, i18n("Total data with unknown direction")) ;
}

/*  KNDSummary								*/
/*  ~KNDSummary	: Destructor for packet display object			*/
/*  (returns)	:		:					*/

KNDSummary::~KNDSummary ()
{
}

/*  KNDSummary								*/
/*  execute	: Set executing flag					*/
/*  _going	: bool		: Executing				*/
/*  (returns)	: void		:					*/

void	KNDSummary::execute
	(	bool	_going
	)
{
	going	= _going ;	/* Not the requsted execution state	*/
	frozen	= false	 ;	/* Changes always reset frozen state	*/

	if (going)
	{	memset (s_accept,   0, sizeof(s_accept  )) ;
		memset (s_pktbytes, 0, sizeof(s_pktbytes)) ;
		memset (s_datbytes, 0, sizeof(s_pktbytes)) ;
		ctrlSet.show () ;
	}
}

/*  KNDSummary								*/
/*  update	: Update counts for specified direction			*/
/*  dir		: Direction	: Direction in question			*/
/*  (returns)	: void		:					*/

void	KNDSummary::update
	(	Direction	dir
	)
{
	v_accept  [dir]->setText (ItoA (s_accept  [dir])) ;
	v_pktbytes[dir]->setText (ItoA (s_pktbytes[dir])) ;
	v_datbytes[dir]->setText (ItoA (s_datbytes[dir])) ;
}

/*  KNDSummary								*/
/*  addPacket	: Add a new packet to the display			*/
/*  pktinfo	: PktInfo *	: Packet information			*/
/*  (returns)	: void		:					*/

void	KNDSummary::addPacket
	(	PktInfo	*pktinfo
	)
{
	Direction dir ;

	if (pktinfo->ip != NULL)
	{
		IP	*ip	= (IP *)pktinfo->ip ;
		bool	out	= IPIsThisHost ((char *)&ip->ip_src) ;
		bool	in	= IPIsThisHost ((char *)&ip->ip_dst) ;

		if	(in & out) dir	= Local		;
		else if (in	 ) dir	= Incoming	;
		else if (out	 ) dir	= Outgoing	;
		else		   dir	= Passing	;
	}
	else	dir	= Unknown ;

	s_accept  [dir] += 1 ;
	s_pktbytes[dir] += pktinfo->piHdr.pktlen ;
	s_datbytes[dir] += pktinfo->datlen ;

	if (onview && !frozen) update (dir) ;
}


/*  KNDSummary								*/
/*  redisplay	: Rebuild display					*/
/*  (returns)	: void		:					*/

void	KNDSummary::redisplay ()
{
	update	(Incoming) ;
	update	(Outgoing) ;
	update	(Passing ) ;
	update	(Local   ) ;
	update	(Unknown ) ;
}

/*  KNDSummary								*/
/*  setOnview	: Set whether we are on view or not			*/
/*  _onview	: bool		: TRUE if on view			*/
/*  (returns)	: void		:					*/

void	KNDSummary::setOnview
	(	bool	_onview
	)
{
	if ((onview = _onview) && !frozen)
		redisplay () ;
}

/*  KNDSummary								*/
/*  freeze	: Freeze or unfreeze the display			*/
/*  _frozen	: bool		: New state				*/

void	KNDSummary::freeze
	(	bool	_frozen
	)
{
	if (!(frozen = _frozen) && onview)
		redisplay () ;
}


extern	"C"
{
PluginSet *getPlugin
	  (	KNDView	*_parent,
		KConfig	*config
	  )
{
	PluginSet *pl	= (PluginSet *)malloc(sizeof(KNDPlugin *) + sizeof(PluginSet)) ;

	pl->nPlugins	= 1	    ;
	pl->plugin[0]	= new KNDSummary (_parent, config) ;

	getVersion (pl->major, pl->minor) ;
	pl->name   = "summary" ;

	return	pl ;
}
}
