/***************************************************************************
                        knd_summary.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef	KND_SUMMARY_H
#define KND_SUMMARY_H 

#include	<qgroupbox.h>
#include	"ksnuffle.h"
#include	"ctrlset.h"
#include	"knd_plugin.h"


/*  KNDSummary	:							*/
/*  Instances of this class handle summary display of data coming	*/
/*  from the associated monitor.					*/

class	KNDSummary : public KNDPlugin
{
	Q_OBJECT

	KNDControlSet	ctrlSet		;

	QGroupBox	g_stats		;
						/* Labels ...		*/
	QLabel		l_accept	;	/* Packets accepted	*/
	QLabel		l_dropped	;	/* Packets dropped	*/
	QLabel		l_missed	;	/* Packets missed	*/
	QLabel		l_pktbytes	;	/* Packet bytes		*/
	QLabel		l_datbytes	;	/* Packet data		*/
	QLabel		l_in		;	/* Incoming ...		*/
	QLabel		l_out		;	/* Outgoing ...		*/
	QLabel		l_pass		;	/* Passing		*/
	QLabel		l_local		;	/* Local		*/
	QLabel		l_what		;	/* Unknown		*/
						/* Values ...		*/
	QLabel		v_accepti	;	/* Packets in accepted	*/
	QLabel		v_accepto	;	/* Packets out accepted	*/
	QLabel		v_acceptp	;	/* Packets passing	*/
	QLabel		v_acceptl	;	/* Packets local		*/
	QLabel		v_acceptu	;	/* Packets unknown	*/
	QLabel		v_dropped	;	/* Packets dropped	*/
	QLabel		v_missed	;	/* Packets missed	*/
	QLabel		v_pktbytesi	;	/* Packet bytes in	*/
	QLabel		v_pktbyteso	;	/* Packet bytes out	*/
	QLabel		v_pktbytesp	;	/* Packet bytes passing	*/
	QLabel		v_pktbytesl	;	/* Packet bytes local	*/
	QLabel		v_pktbytesu	;	/* Packet bytes unknown	*/
	QLabel		v_datbytesi	;	/* Packet data in	*/
	QLabel		v_datbyteso	;	/* Packet data out	*/
	QLabel		v_datbytesp	;	/* Packet data passing	*/
	QLabel		v_datbytesl	;	/* Packet data local	*/
	QLabel		v_datbytesu	;	/* Packet data unknown	*/

	QLabel		*v_accept  [5]	;
	QLabel		*v_pktbytes[5]	;
	QLabel		*v_datbytes[5]	;

	int		s_dropped	;	/* Total dropped	*/
	int		s_missed	;	/* Total missed		*/
	int		s_accept   [5]	;	/* Total packets	*/
	int		s_pktbytes [5]	;	/* Total bytes		*/
	int		s_datbytes [5]	;	/* Total data		*/

	bool		onview		;	/* Display on view	*/
	bool		going		;	/* Display going	*/
	bool		frozen		;	/* Display is frozen	*/

	void	redisplay ()		;
	void	update	  (Direction)	;

public	:
	KNDSummary	  (KNDView *, KConfig *);
       ~KNDSummary	  ()		;

	void	addPacket	(PktInfo *) ;
	void	setOnview	(bool)	 ;
	void	execute		(bool)	 ;
	void	freeze		(bool)	 ;

	virtual	cchar	*getLabel () { return "Summary" ; } ;
	virtual	bool	isConfig  () { return false	; } ;
}	;


#endif	// KND_SUMMARY_H
