/***************************************************************************
                          capremote.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999,2000 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include	<errno.h>
#include	<unistd.h>
#include	<fcntl.h>

#include	<qlist.h>
#include	<ksock.h>

#include	"ksnuffle.h"
#include	"pcaphdr.h"
#include	"netpcap.h"
#include	"capture.h"
#include	"knd_pcaploc.h"

/*  CapRemote								*/
/*  CapRemote	: Constructor for remote capture			*/
/*  sock	: int		: Socket to KSnuffle			*/
/*  (returns)	: CapLocal	:					*/

CapRemote::CapRemote
	(	int	sock
	)
	:
	sock	(sock)
{
}

/*  CapRemote								*/
/*  ~CapRemote	: Desstructor for remote capture			*/
/*  		:							*/

CapRemote::~CapRemote ()
{
}

/*  CapRemote								*/
/*  gotPacket	: Pass packet back to ksnuffle program			*/
/*  pktdata	: PktData &	: packet data				*/
/*  (returns)	: void		:					*/

void	CapRemote::gotPacket
	(	PktInfo	*pktinfo
	)
{
	write	(sock, pktinfo, sizeof(PktInfo)) ;
}

/*  CapRemote								*/
/*  gotState	: Pass capture state back to ksnuffle program		*/
/*  state	: MState	: Capture state				*/
/*  (returns)	: void		:					*/

void	CapRemote::gotState
	(	MState	state
	)
{
	PktInfo	pktinfo	;

	pktinfo.tag = RS_STATE ;
	sprintf	((char *)pktinfo.data, "%d", state) ;
	write	(sock, &pktinfo, sizeof(pktinfo)) ;
}
